"""
Author: Michel Peltriaux
Organization: Struktur- und Genehmigungsdirektion Nord, Rhineland-Palatinate, Germany
Contact: michel.peltriaux@sgdnord.rlp.de
Created on: 09.11.20

"""
import random
import string


def generate_random_string(length: int, use_numbers: bool = False, use_letters_lc: bool = False, use_letters_uc: bool = False) -> str:
    """
    Generates a random string of variable length
    """
    elements = []
    if use_numbers:
        elements.append(string.digits)
    if use_letters_lc:
        elements.append(string.ascii_lowercase)
    if use_letters_uc:
        elements.append(string.ascii_uppercase)

    elements = "".join(elements)
    ret_val = "".join(random.choice(elements) for i in range(length))
    return ret_val
